VERSION 5.00
Begin VB.Form frmProcessNotify 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Process notify"
   ClientHeight    =   1710
   ClientLeft      =   45
   ClientTop       =   360
   ClientWidth     =   3195
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1710
   ScaleWidth      =   3195
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame fraProcess 
      Caption         =   "Wait process"
      Height          =   1575
      Left            =   60
      TabIndex        =   0
      Top             =   60
      Width           =   3045
      Begin VB.CommandButton cmdRun 
         Caption         =   "Run"
         Height          =   390
         Left            =   780
         TabIndex        =   2
         Top             =   1020
         Width           =   1440
      End
      Begin VB.TextBox txtProcess 
         Height          =   360
         Left            =   105
         TabIndex        =   1
         Text            =   "notepad"
         Top             =   555
         Width           =   2820
      End
      Begin VB.Label lblInfo 
         Caption         =   "Execute file:"
         Height          =   255
         Index           =   1
         Left            =   105
         TabIndex        =   3
         Top             =   315
         Width           =   1635
      End
   End
End
Attribute VB_Name = "frmProcessNotify"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' // clsTrickWait - demonstration of waiting for the end of the process.
' //  Krivous Anatolii Anatolevich (The trick), 2015

Option Explicit

Private Declare Function OpenProcess Lib "kernel32" ( _
                         ByVal dwDesiredAccess As Long, _
                         ByVal bInheritHandle As Long, _
                         ByVal dwProcessId As Long) As Long
Private Declare Function CloseHandle Lib "kernel32" ( _
                         ByVal hObject As Long) As Long

Private Const SYNCHRONIZE   As Long = &H100000
Private Const INFINITE      As Long = -1

Dim WithEvents proc As clsTrickWait ' // Asynchronous waiter
Attribute proc.VB_VarHelpID = -1

Private Sub cmdRun_Click()
    Dim pid         As Long
    Dim hProcess    As Long
    
    ' // If already waiting
    If proc.IsActive Then
        Select Case MsgBox("Process enabled. Abort?", vbYesNo Or vbQuestion)
        Case vbYes: proc.Abort  '  
        Case Else: Exit Sub
        End Select
    End If
    ' // Launch the process
    pid = Shell(txtProcess)
    ' // Open the process for the synchronization
    hProcess = OpenProcess(SYNCHRONIZE, False, pid)

    ' // Launch the asynchronous waiting
    proc.vbWaitForSingleObject hProcess, INFINITE
    
End Sub

Private Sub Form_Load()
    Set proc = New clsTrickWait
End Sub

' // Event occurs when the process will end
Private Sub proc_OnWait(ByVal Handle As Long, ByVal Result As Long)

    MsgBox "Process has ended." & vbNewLine & "Handle = " & Handle & vbNewLine & "Result = " & Result
    CloseHandle Handle
    
End Sub
